; Programa: Ejemplo de agente basico humano para jugar al mastermind
;
; Asignatura: Introduccin a la Inteligencia Artificial
;             CSI - ULL
; Prctica: 3a (sistemas de produccin)
; Profesor: Patricio Garca
; Fecha: 11/5/2001
; Comentarios:
;              Hace uso del package mastmind
;              (load "mastmind")
;
; ToDo list:

(use-package "mastmind")

; Agente humano

(defun agente-humano ()
  "Agente humano para jugar al mastermind"
  (format t "Introduzca lista del codigo a testear (~D digitos, ~D colores):~%" *num-elem-mm* *num-digitos-mm*)
  (do (codigo-in
       (resultado '(0 0)))
      ((= *num-elem-mm* (first resultado)) codigo-in)
    (do ()
	(nil)
      (format t "Codigo? ")
      (setf codigo-in (read))
      (if (and (listp codigo-in) (= (length codigo-in) *num-elem-mm*))
	  (return))
      (print "Codigo incorrecto, intentelo otra vez"))
    ; Llamada a mastmind
    (setf resultado (test-master-mind codigo-in))
    (format t "                   Negros: ~D, Blancos: ~D~%"
	    (first resultado)
	    (second resultado))))

; Para pruebas:
;
; (load "mastmind")(load "agente-humano")
; (inic-master-mind #'agente-humano :verb t :tipo '(3 4))